import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;

/***
 * @author Suat
 * 
 *         This is the class which contains the main method. we differ here in
 *         tree-view and box-view whether which view the user want to have. for
 *         take it simple it is also possible to have the both views.
 * 
 */

public class LinearTree {

	/**
	 * @param args
	 *            takes the arguments from console. Here allowed to type to
	 *            arguments. The first argument is the filename of the given
	 *            proof and the second argument is the type of view e.g.: java
	 *            LinearTree [filename] [linear| tree| lineartree| treelinear]
	 */
	public static void startIt(String[] args) throws NullPointerException {
		int once = 0;
		FileWriter foutTree = null;
		FileWriter foutLinear = null;
		FileReader fin = null;
		Scanner src = null;
		ArrayList<String> listIn = new ArrayList<String>();

		LinearView linear = new LinearView();
		TreeView tree = null;
		boolean inputFormat = true;

		try {

			fin = new FileReader(args[0]);

			if (args[1].equalsIgnoreCase("linear")
					|| args[1].equalsIgnoreCase("tree")
					|| args[1].equalsIgnoreCase("lineartree")
					|| args[1].equalsIgnoreCase("treelinear")) {
			} else
				throw new IllegalArgumentException(
						"\n**************************************************************\n"
								+ "** Wrong tex format! Type: [linear|tree|lineartree|treelinear]"
								+ "\n**************************************************************\n");

			src = new Scanner(fin).useDelimiter("\n");

			listIn.add("\n");

			while (src.hasNext()) {
				String line = src.next();
				if (line.trim().length() != 0) {
					line = line.replaceAll("\\s+", "");
					listIn.add(line);
				}
			}

			for (int i = 1; i < listIn.size(); i++)
				if (!listIn
						.get(i)
						.matches(
								"\\d+;.+=.+;(cong\\d+(,\\d+)*|trans\\d+,\\d+|sym\\d+|app|app\\d+|ref|prem)||\\n")) {
					inputFormat = false;
					once++;
					if (once == 1) {
						once++;
						System.out
								.println("**************************************************************");
						System.out
								.println("**** The line/lines is/are below wrong! **********************");
						System.out
								.println("**************************************************************");
						System.out
								.println("**** A valid format has the structure ************************");
						System.out
								.println("\\d+;.+=.+;(cong\\d+(,\\d+)*|trans\\d+,\\d+|sym\\d+|app\\d+|ref|prem)");
						System.out
								.println("White-spaces and  blank-line don't cause error! They are allowed!");
						System.out
								.println("**************************************************************");

					}
					System.out.println(listIn.get(i));
				}

			if (args[1].equalsIgnoreCase("linear") && inputFormat == true) {
				foutLinear = new FileWriter("proof_linear.tex");

				for (String str : linear.linearview(listIn))
					foutLinear.write(str.replace("\\s+", ""));
				foutLinear.close();

			} else if (args[1].equalsIgnoreCase("tree") && inputFormat == true) {
				Boolean bool = true;
				for (int i = 1; i < listIn.size(); i++)
					if (listIn.get(i).split(";")[2]
							.matches("\\s*cong\\d+,\\d+,\\d+,\\d+,\\d+,\\d+,\\d+,\\d+,\\d+(,\\d+)+\\s*")) {
						bool = false;

						System.out
								.print("**************************************************************\n"
										+ "**** Cong has more than 9 arguments **************************\n"
										+ "**** Not allowed in treeview but in linearview ***************\n"
										+ "**** No file created!                          ***************\n"
										+ "**************************************************************\n");
						break;
					}
				if (bool) {
					tree = new TreeView(listIn);

					foutTree = new FileWriter("proof_tree.tex");
					for (String str : tree.listOut)
						foutTree.write(str);
					foutTree.close();
				}
			} else if (args[1].equalsIgnoreCase("linearTree")
					&& inputFormat == true
					|| args[1].equalsIgnoreCase("treeLinear")
					&& inputFormat == true) {
				foutLinear = new FileWriter("proof_linear.tex");
				for (String str : linear.linearview(listIn))
					foutLinear.write(str);
				foutLinear.close();
				Boolean bool = true;
				for (int i = 1; i < listIn.size(); i++)
					if (listIn.get(i).split(";")[2]
							.matches("\\s*cong\\d+,\\d+,\\d+,\\d+,\\d+,\\d+,\\d+,\\d+,\\d+(,\\d+)+\\s*")) {
						bool = false;
						System.out
								.print("**************************************************************\n"
										+ "**** Cong has more than 9 arguments **************************\n"
										+ "**** Not allowed in treeview but in linearview ***************\n"
										+ "**** proof_linear.tex is created!			  ***************\n"
										+ "**************************************************************\n");
						break;
					}

				if (bool) {
					tree = new TreeView(listIn);

					foutTree = new FileWriter("proof_tree.tex");
					for (String str : tree.listOut)
						foutTree.write(str);
					foutTree.close();
				}
			}
			fin.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			System.out
					.println("**************************************************************\n"
							+ "File not found! Please write the name of the file correctly! \n"
							+ "**************************************************************");
		} catch (IllegalArgumentException e) {
			// TODO Auto-generated catch block
			System.out.println(e.getMessage());

		}

		catch (ArrayIndexOutOfBoundsException e) {

			if (args.length == 0)
				System.out
						.print("**************************************************************\n"
								+ "**** No argument entered! Type like: *************************\n"
								+ "java LinearTree [filename] [linear|tree|lineartree|treelinear]\n"
								+ "**************************************************************\n");
			else if (args.length == 1)
				System.out
						.print("**************************************************************\n"
								+ "**** Second argument not entered! Type like: *****************\n"
								+ "java LinearTree [filename] [linear|tree|lineartree|treelinear]\n"
								+ "**************************************************************\n");

		} catch (IOException e) {
			System.out.println(e.getMessage());
		}

	}

	public static void main(String[] args) throws IOException,
			NullPointerException {
		try {
			startIt(args);
		} catch (NullPointerException e) {
		}

	}
}
